package it.condarelli.e4.writer.handlers;

import it.condarelli.e4.writer.ui.parts.MasterPart;
import it.condarelli.writer.model.world.Model;
import it.condarelli.writer.model.world.SafeModel;

import java.lang.reflect.InvocationTargetException;

import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.emf.common.util.URI;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;

public class OpenHandler {
	@Inject private EPartService partService;
	
	@CanExecute
	public boolean canExecute(IEclipseContext context, @Optional Model model) {
		// TODO: allow model close
		return model == null;
	}

	@Execute
	public void execute(IEclipseContext context, @Optional Model model,
			@Named(IServiceConstants.ACTIVE_SHELL) Shell shell)
			throws InvocationTargetException, InterruptedException {
		System.out.println(context);
		if (model != null) {
			System.out.println("Model already opened!");
			return;
		}
		FileDialog dialog = new FileDialog(shell);
		dialog.setFilterExtensions(new String[] { "*.world", "*.*" });
		dialog.setFilterNames(new String[] { "World files", "All files" });
		String selected = dialog.open();
		if (selected != null) {
			model = new SafeModel(URI.createFileURI(selected));
			//context.set(Model.class.getName(), model);
			MPart p = partService.findPart(MasterPart.ID);
			Object o = p.getObject();
			if (o instanceof MasterPart) {
				MasterPart masterPart = (MasterPart) o;
				masterPart.setModel(model);
			}
			p = partService.findPart("it.condarelli.e4.writer.main");
			if (p != null) {
				IEclipseContext appContext = p.getContext();
				System.out.println(appContext);
				appContext.set(Model.class, model);
			} else {
				while (context != null) {
					if (context.toString().contains("it.condarelli.e4.writer.main")) {
						context.set(Model.class, model);
						break;
					}
					System.out.println(String.format("--%s--", context));
					context = context.getParent();
				}
			}
		}
	}
}
