/*******************************************************************************
 * Copyright (c) 2010 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package it.condarelli.e4.writer.handlers;

import it.condarelli.e4.writer.ui.parts.MasterPart;
import it.condarelli.writer.model.world.Model;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
//import org.eclipse.e4.ui.workbench.Persist;

public class SaveHandler {
	@CanExecute
	public boolean canExecute(@Optional Model model) {
		if (model == null) {
			return false;
		}
		return model.isDirty();
	}

	/*
	@Execute
	public void execute(
			IEclipseContext context,
			@Named(IServiceConstants.ACTIVE_SHELL) Shell shell,
			@Named(IServiceConstants.ACTIVE_PART) final MContribution contribution)
			throws InvocationTargetException, InterruptedException {
		final IEclipseContext pmContext = context.createChild();

		ProgressMonitorDialog dialog = new ProgressMonitorDialog(shell);
		dialog.open();
		dialog.run(true, true, new IRunnableWithProgress() {
			public void run(IProgressMonitor monitor)
					throws InvocationTargetException, InterruptedException {
				pmContext.set(IProgressMonitor.class.getName(), monitor);
				if (contribution != null) {
					Object clientObject = contribution.getObject();
					ContextInjectionFactory.invoke(clientObject, Persist.class, //$NON-NLS-1$
							pmContext, null);
				}
			}
		});
		
		pmContext.dispose();
	}
	*/
	@Execute
	public void execute(EPartService partService) {
		MPart part = partService.findPart(MasterPart.ID);
		partService.savePart(part, false);
	}
}
