package it.condarelli.e4.writer.handlers;

import it.condarelli.writer.model.world.Model;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.di.annotations.Optional;

public class UndoHandler {

	@CanExecute
	public boolean canExecute(@Optional Model model) {
		if (model == null)
			return false;
		return model.getEditingDomain().getCommandStack().canUndo();
	}

	@Execute
	public void execute(Model model) {
		model.getEditingDomain().getCommandStack().undo();
	}
	
}
