package it.condarelli.e4.writer.modelif;

import it.condarelli.e4.resourcemanager.IResourceManager;
import it.condarelli.writer.model.world.Actor;
import it.condarelli.writer.model.world.Book;
import it.condarelli.writer.model.world.Chapter;
import it.condarelli.writer.model.world.Item;
import it.condarelli.writer.model.world.Location;
import it.condarelli.writer.model.world.Scene;
import it.condarelli.writer.model.world.World;
import it.condarelli.writer.model.world.impl.ActorImpl;
import it.condarelli.writer.model.world.impl.BookImpl;
import it.condarelli.writer.model.world.impl.ChapterImpl;
import it.condarelli.writer.model.world.impl.ItemImpl;
import it.condarelli.writer.model.world.impl.LocationImpl;
import it.condarelli.writer.model.world.impl.SceneImpl;
import it.condarelli.writer.model.world.impl.WorldImpl;

import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import org.eclipse.swt.graphics.Image;

public class IconProvider {
	@Inject static private IResourceManager resourceManager;
    
    static private Map<String, String> iconMap = null;
    static private Map<String, String> getIconMap() {
        if (iconMap == null) {
            iconMap = new HashMap<String, String>();
            add(Scene.class, "PaperTrail");
            add(Chapter.class, "CleanDocuments");
            add(Book.class, "GreenBook");
            add(Actor.class, "Actor");
            add(Item.class, "Things");
            add(Location.class, "Compass");
            add(World.class, "World");
            add(SceneImpl.class, "PaperTrail");
            add(ChapterImpl.class, "CleanDocuments");
            add(BookImpl.class, "GreenBook");
            add(ActorImpl.class, "Actor");
            add(ItemImpl.class, "Things");
            add(LocationImpl.class, "Compass");
            add(WorldImpl.class, "World");
        }
        return iconMap;
    }
    static public String imageName(String className) {
        return getIconMap().get(className);
    }
    static private String o2s(Object o) {
        String s;
        if (o instanceof String) 
            s =  (String) o;
        else if (o instanceof Class<?>)
            s = ((Class<?>) o).getName();
        else
            s = o.getClass().getName();
        return s;
    }
    static public Image getIcon(int size, Object o) {
//   	 if (resourceManager == null) {
//   		 resourceManager = new ResourceManager();
//   	 }
        return resourceManager.getImage(imageName(o2s(o)), size);
    }
    static public Image getIconSmall(Object o) {
        return getIcon(16, o);
    }
    static public Image getIconMedium(Object o) {
        return getIcon(32, o);
    }
    static public Image getIconLarge(Object o) {
        return getIcon(64, o);
    }
    static public Image getIconHuge(Object o) {
        return getIcon(128, o);
    }

    static public void add(Object o, String id) {
        getIconMap().put(o2s(o), id);
    }
}
