package it.condarelli.e4.writer.ui.composites;

import it.condarelli.writer.model.world.Actor;
import it.condarelli.writer.model.world.Scene;
import it.condarelli.writer.model.world.WorldPackage;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.databinding.edit.EMFEditProperties;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.RemoveCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.jface.databinding.swt.IWidgetValueProperty;
import org.eclipse.jface.databinding.swt.WidgetProperties;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.ExpandBar;
import org.eclipse.swt.widgets.ExpandItem;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;

public class SceneComposite extends PartComposite {
	private EditingDomain	editingDomain;
	private Text				txtTitle;
	private Text				txtDesc;
	private Text				txtWords;
	private Text				txtcontents;
	private ListViewer		lvActors;
	private ComboViewer		cvActors;
	private List				lstActors;
	private Combo				cmbActors;

	protected Scene getScene() {
		return (Scene) oValue.getValue();
	}

	public SceneComposite(final Composite parent) {
		super(parent, Scene.class);
	}

	@Override
	public void setFocus() {
		txtTitle.setFocus();
	}

	public void setScene(Scene scene) {
		setValue(scene);
	}

	/**
	 * @wbp.parser.entryPoint
	 */
	@Override
	protected void createContents(Composite parent) {
		parent.setLayout(new GridLayout(1, false));

		ExpandBar expandBar = new RadioExpandBar(parent, SWT.MAX | SWT.RADIO);
		expandBar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		ExpandItem xpiOverview = new ExpandItem(expandBar, SWT.NONE);
		xpiOverview.setExpanded(true);
		xpiOverview.setText("Overview");

		Composite cmpOverview = new Composite(expandBar, SWT.NONE);
		xpiOverview.setControl(cmpOverview);
		xpiOverview.setHeight(200);
		cmpOverview.setLayout(new GridLayout(3, false));

		Button btnTitle = new Button(cmpOverview, SWT.CHECK);
		btnTitle.setText("Title:");

		txtTitle = new Text(cmpOverview, SWT.BORDER);
		txtTitle.setText("[Title]");
		txtTitle.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		Composite cmpThings = new Composite(cmpOverview, SWT.NONE);
		GridData gd_cmpThings = new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 3);
		gd_cmpThings.widthHint = 150;
		cmpThings.setLayoutData(gd_cmpThings);
		GridLayout gl = new GridLayout(1, false);
		gl.marginWidth = 0;
		gl.marginHeight = 0;
		cmpThings.setLayout(gl);

		RadioExpandBar exbThings = new RadioExpandBar(cmpThings, SWT.RADIO);
		exbThings.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		ExpandItem xpiActors = new ExpandItem(exbThings, SWT.NONE);
		xpiActors.setExpanded(true);
		xpiActors.setText("Actors");

		Composite cmpActors = new Composite(exbThings, SWT.NONE);
		xpiActors.setControl(cmpActors);
		xpiActors.setHeight(164);
		gl = new GridLayout(1, false);
		gl.marginWidth = 0;
		gl.marginHeight = 0;
		cmpActors.setLayout(gl);

		lvActors = new ListViewer(cmpActors, SWT.BORDER | SWT.V_SCROLL | SWT.READ_ONLY);
		lstActors = lvActors.getList();
		lstActors.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		cvActors = new ComboViewer(cmpActors, SWT.READ_ONLY);
		cmbActors = cvActors.getCombo();
		cmbActors.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
			}
		});
		cmbActors.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent e) {
				if (e.widget != cmbActors)
					return;
				if (e.character != SWT.CR)
					return;
				toggleActor();
				e.doit = false;
			}

		});
		cmbActors.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		// Combo cmbActors = cvActors.getCombo();

		ExpandItem xpiItems = new ExpandItem(exbThings, SWT.NONE);
		xpiItems.setText("Items");

		Composite cmpItems = new Composite(exbThings, SWT.NONE);
		xpiItems.setControl(cmpItems);
		xpiItems.setHeight(xpiItems.getControl().computeSize(SWT.DEFAULT, SWT.DEFAULT).y);

		ExpandItem xpiPlaces = new ExpandItem(exbThings, SWT.NONE);
		xpiPlaces.setText("Places");

		Composite cmpPlaces = new Composite(exbThings, SWT.NONE);
		xpiPlaces.setControl(cmpPlaces);
		xpiPlaces.setHeight(xpiPlaces.getControl().computeSize(SWT.DEFAULT, SWT.DEFAULT).y);

		txtDesc = new Text(cmpOverview, SWT.BORDER | SWT.WRAP | SWT.MULTI);
		txtDesc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));

		Label lblWords = new Label(cmpOverview, SWT.NONE);
		lblWords.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblWords.setText("Words:");

		txtWords = new Text(cmpOverview, SWT.BORDER);
		txtWords.setText("[Words]");
		txtWords.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		ExpandItem xpiTimeline = new ExpandItem(expandBar, SWT.NONE);
		xpiTimeline.setText("Timeline");

		ExpandItem xpiContents = new ExpandItem(expandBar, SWT.NONE);
		xpiContents.setText("Contents");

		Composite cmpContents = new Composite(expandBar, SWT.NONE);
		xpiContents.setControl(cmpContents);
		xpiContents.setHeight(xpiContents.getControl().computeSize(SWT.DEFAULT, SWT.DEFAULT).y);
		cmpContents.setLayout(new FillLayout(SWT.HORIZONTAL));

		txtcontents = new Text(cmpContents, SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
		txtcontents.setText("[Contents]");
	}

	@Override
	protected void createDataBindings(EditingDomain editingDomain, DataBindingContext bindingContext) {
		this.editingDomain = editingDomain;
		/**/
		IWidgetValueProperty txt = WidgetProperties.text(SWT.Modify);
		// IWidgetListProperty lst = WidgetProperties.items();
		//
		bindingContext.bindValue(txt.observeDelayed(400, txtTitle), EMFEditProperties.value(editingDomain, WorldPackage.Literals.IBASE__TITLE).observeDetail(oValue));
		bindingContext.bindValue(txt.observeDelayed(400, txtDesc), EMFEditProperties.value(editingDomain, WorldPackage.Literals.IBASE__DESC).observeDetail(oValue));
		bindingContext.bindValue(txt.observeDelayed(400, txtWords), EMFEditProperties.value(editingDomain, WorldPackage.Literals.SCENE__WORD_COUNT).observeDetail(oValue));
		bindingContext.bindValue(txt.observeDelayed(400, txtcontents), EMFEditProperties.value(editingDomain, WorldPackage.Literals.IBASE__CONTENT).observeDetail(oValue));

		ObservableListContentProvider cp = new ObservableListContentProvider();
		cvActors.setContentProvider(cp);
		cvActors.setLabelProvider(new ObservableMapLabelProvider(EMFEditProperties.value(editingDomain, WorldPackage.Literals.ACTOR__NAME).observeDetail(cp.getKnownElements())));
		cvActors.setInput(EMFEditProperties.list(editingDomain, WorldPackage.Literals.IBASE__ACTORS).observeDetail(oValue));

		cp = new ObservableListContentProvider();
		lvActors.setContentProvider(cp);
		lvActors.setLabelProvider(new ObservableMapLabelProvider(EMFEditProperties.value(editingDomain, WorldPackage.Literals.ACTOR__NAME).observeDetail(cp.getKnownElements())));
		lvActors.setInput(EMFEditProperties.list(editingDomain, WorldPackage.Literals.SCENE__ACTOR).observeDetail(oValue));
		/**/
	}

	private void toggleActor() {
		if (!cmbActors.getListVisible()) {
			String name = cmbActors.getText();
			Scene sc = getScene();
			for (Actor a : sc.getActors()) {
				if (name.equals(a.getName())) {
					Command cmd = null;
					for (String s : lstActors.getItems()) {
						if (s.equals(name)) {
							cmd = RemoveCommand.create(editingDomain, sc, WorldPackage.Literals.SCENE__ACTOR, a);
							break;
						}
					}
					if (cmd == null) {
						cmd = AddCommand.create(editingDomain, sc, WorldPackage.Literals.SCENE__ACTOR, a);
					}
					if (cmd.canExecute())
						cmd.execute();
					break;
				}
			}
		}
	}
}
