package it.condarelli.e4.writer.ui.parts;

import it.condarelli.e4.writer.ui.composites.BookComposite;
import it.condarelli.writer.model.world.Book;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

public class BookPart {
	public static final String ID = "it.condarelli.e4.writer.ui.parts.book";
	
	@Inject
	private EPartService	partService;

	private BookComposite w;

	public BookPart() {
		System.out.println("BookPart.BookPart()");
	}

	@PostConstruct
	public void createControls(Composite parent) {
		w = new BookComposite(parent);
	}
	
	@Focus
	public void setFocus() {
		w.setFocus();
	}
	
	@PreDestroy
	public void dispose() {
		
	}
	
	@Inject
	public void setBook(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) final Book book) {
		if (book != null) {
			System.out.println("BookPart.setBook(): "+book.getTitle());
			if (w != null) {
				w.setBook(book);
				setFocus();
			} else {
				Display.getCurrent().asyncExec(new Runnable() {
					@Override
					public void run() {
						if (w != null) {
							w.setBook(book);
							setFocus();
						}
					}
				});
			}
		} else {
			System.out.println("BookPart.setBook(null):");
		}
	}

}
