package it.condarelli.e4.writer.ui.parts;

import it.condarelli.e4.writer.ui.composites.ChapterComposite;
import it.condarelli.writer.model.world.Chapter;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

public class ChapterPart {
	public static final String ID = "it.condarelli.e4.writer.ui.parts.chapter";

	private ChapterComposite w;

	public ChapterPart() {
		System.out.println("ChapterPart.ChapterPart():");
	}

	@PostConstruct
	public void createControls(Composite parent) {
		w = new ChapterComposite(parent);
	}
	
	@Focus
	public void setFocus() {
		if (w != null)
			w.setFocus();
	}
	
	@PreDestroy
	public void dispose() {
		
	}
	
	@Inject
	public void setChapter(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) final Chapter chapter) {
		if (chapter != null) {
			System.out.println("ChapterPart.setChapter(): "+chapter.getTitle());
			if (w != null) {
				w.setChapter(chapter);
				setFocus();
			} else {
				Display.getCurrent().asyncExec(new Runnable() {
					@Override
					public void run() {
						if (w != null) {
							w.setChapter(chapter);
							setFocus();
						}
					}
				});
			}
		} else {
			System.out.println("ChapterPart.setChapter(null):");
		}
	}

}
