package it.condarelli.e4.writer.ui.parts;

import it.condarelli.e4.writer.ui.composites.SceneComposite;
import it.condarelli.writer.model.world.Scene;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;
import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.services.IServiceConstants;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

public class ScenePart {
	public static final String ID = "it.condarelli.e4.writer.ui.parts.scene";

	private SceneComposite w;

	public ScenePart() {
		System.out.println("ScenePart.ScenePart():");
	}

	@PostConstruct
	public void createControls(Composite parent) {
		w = new SceneComposite(parent);
	}
	
	@Focus
	public void setFocus() {
		if (w != null)
			w.setFocus();
	}
	
	@PreDestroy
	public void dispose() {
		
	}

	@Inject
	public void setScene(@Optional @Named(IServiceConstants.ACTIVE_SELECTION) final Scene scene) {
		if (scene != null) {
			System.out.println("ScenePart.setScene():"+scene.getTitle());
			if (w != null) {
				w.setScene(scene);
				setFocus();
			} else {
				Display.getCurrent().asyncExec(new Runnable() {
					@Override
					public void run() {
						if (w != null) {
							w.setScene(scene);
							setFocus();
						}
					}
				});
			}
		} else {
			System.out.println("ScenePart.setScene(null):");
		}
	}

}
