/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Actor Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see it.condarelli.writer.model.world.WorldPackage#getActorType()
 * @model
 * @generated
 */
public enum ActorType implements Enumerator {
   /**
	 * The '<em><b>Unknown</b></em>' literal object.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #UNKNOWN_VALUE
	 * @generated
	 * @ordered
	 */
   UNKNOWN(0, "Unknown", "Unknown"),

   /**
	 * The '<em><b>World</b></em>' literal object.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #WORLD_VALUE
	 * @generated
	 * @ordered
	 */
   WORLD(1, "World", "World"),

   /**
	 * The '<em><b>Book</b></em>' literal object.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #BOOK_VALUE
	 * @generated
	 * @ordered
	 */
   BOOK(2, "Book", "Book"),

   /**
	 * The '<em><b>Local</b></em>' literal object.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #LOCAL_VALUE
	 * @generated
	 * @ordered
	 */
   LOCAL(3, "Local", "Local");

   /**
	 * The '<em><b>Unknown</b></em>' literal value.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of '<em><b>Unknown</b></em>' literal object isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @see #UNKNOWN
	 * @model name="Unknown"
	 * @generated
	 * @ordered
	 */
   public static final int UNKNOWN_VALUE = 0;

   /**
	 * The '<em><b>World</b></em>' literal value.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of '<em><b>World</b></em>' literal object isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @see #WORLD
	 * @model name="World"
	 * @generated
	 * @ordered
	 */
   public static final int WORLD_VALUE = 1;

   /**
	 * The '<em><b>Book</b></em>' literal value.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of '<em><b>Book</b></em>' literal object isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @see #BOOK
	 * @model name="Book"
	 * @generated
	 * @ordered
	 */
   public static final int BOOK_VALUE = 2;

   /**
	 * The '<em><b>Local</b></em>' literal value.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of '<em><b>Local</b></em>' literal object isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @see #LOCAL
	 * @model name="Local"
	 * @generated
	 * @ordered
	 */
   public static final int LOCAL_VALUE = 3;

   /**
	 * An array of all the '<em><b>Actor Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   private static final ActorType[] VALUES_ARRAY =
      new ActorType[] {
			UNKNOWN,
			WORLD,
			BOOK,
			LOCAL,
		};

   /**
	 * A public read-only list of all the '<em><b>Actor Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public static final List<ActorType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

   /**
	 * Returns the '<em><b>Actor Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public static ActorType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ActorType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

   /**
	 * Returns the '<em><b>Actor Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public static ActorType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ActorType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

   /**
	 * Returns the '<em><b>Actor Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public static ActorType get(int value) {
		switch (value) {
			case UNKNOWN_VALUE: return UNKNOWN;
			case WORLD_VALUE: return WORLD;
			case BOOK_VALUE: return BOOK;
			case LOCAL_VALUE: return LOCAL;
		}
		return null;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   private final int value;

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   private final String name;

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   private final String literal;

   /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   private ActorType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public int getValue() {
	  return value;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getName() {
	  return name;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getLiteral() {
	  return literal;
	}

   /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public String toString() {
		return literal;
	}
   
} //ActorType
