package it.condarelli.writer.model.world;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import org.eclipse.emf.common.util.Enumerator;

/**
 * @model
 */
public enum ScCommentType implements Enumerator {
	/**
	 * @model value="0" name="Generic"
	 */
	GENERIC(0, "Generic", "Generic"),
	/**
	 * @model value="1" name="Review"
	 */
	REVIEW(1, "Review", "Review"),
	/**
	 * @model value="2" name="Inconsistency"
	 */
	INCONSISTENCY(2, "Inconsistency", "Inconsistency"),
	/**
	 * @model value="3" name="Punctuation"
	 */
	PUNCTUATION(3, "Punctuation", "Punctuation")
;

/**
	 * The '<em><b>Generic</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Generic</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #GENERIC
	 * @model name="Generic"
	 * @generated
	 * @ordered
	 */
	public static final int GENERIC_VALUE = 0;
/**
	 * The '<em><b>Review</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Review</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #REVIEW
	 * @model name="Review"
	 * @generated
	 * @ordered
	 */
	public static final int REVIEW_VALUE = 1;
/**
	 * The '<em><b>Inconsistency</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Inconsistency</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INCONSISTENCY
	 * @model name="Inconsistency"
	 * @generated
	 * @ordered
	 */
	public static final int INCONSISTENCY_VALUE = 2;
/**
	 * The '<em><b>Punctuation</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Punctuation</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PUNCTUATION
	 * @model name="Punctuation"
	 * @generated
	 * @ordered
	 */
	public static final int PUNCTUATION_VALUE = 3;
/**
	 * An array of all the '<em><b>Sc Comment Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final ScCommentType[] VALUES_ARRAY =
		new ScCommentType[] {
			GENERIC,
			REVIEW,
			INCONSISTENCY,
			PUNCTUATION,
		};
/**
	 * A public read-only list of all the '<em><b>Sc Comment Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<ScCommentType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

/**
	 * Returns the '<em><b>Sc Comment Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ScCommentType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ScCommentType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

/**
	 * Returns the '<em><b>Sc Comment Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ScCommentType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ScCommentType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

/**
	 * Returns the '<em><b>Sc Comment Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ScCommentType get(int value) {
		switch (value) {
			case GENERIC_VALUE: return GENERIC;
			case REVIEW_VALUE: return REVIEW;
			case INCONSISTENCY_VALUE: return INCONSISTENCY;
			case PUNCTUATION_VALUE: return PUNCTUATION;
		}
		return null;
	}

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;
/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;
/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ScCommentType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}}
