/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scene</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getChapter <em>Chapter</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getType <em>Type</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getPlot <em>Plot</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getTags <em>Tags</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getStatus <em>Status</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getRelevance <em>Relevance</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getTension <em>Tension</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getHumor <em>Humor</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getQuality <em>Quality</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getGoal <em>Goal</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getConflict <em>Conflict</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getOutcome <em>Outcome</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getActor <em>Actor</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getLocation <em>Location</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getItem <em>Item</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getWordCount <em>Word Count</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.Scene#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @see it.condarelli.writer.model.world.WorldPackage#getScene()
 * @model
 * @generated
 */
public interface Scene extends IBase {
    public static final long DEFAULT_DURATION =  1 * 60 * 60 * 1000; // 1h

    public static final long DEFAULT_GAP    = 23 * 60 * 60 * 1000; // 1d - 1h
   /**
	 * Returns the value of the '<em><b>Chapter</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link it.condarelli.writer.model.world.Chapter#getScene <em>Scene</em>}'.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Chapter</em>' container reference isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Chapter</em>' container reference.
	 * @see #setChapter(Chapter)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Chapter()
	 * @see it.condarelli.writer.model.world.Chapter#getScene
	 * @model opposite="scene" transient="false"
	 * @generated
	 */
   Chapter getChapter();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getChapter <em>Chapter</em>}' container reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chapter</em>' container reference.
	 * @see #getChapter()
	 * @generated
	 */
   void setChapter(Chapter value);

   /**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link it.condarelli.writer.model.world.ScType}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Type</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScType
	 * @see #setType(ScType)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Type()
	 * @model
	 * @generated
	 */
   ScType getType();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScType
	 * @see #getType()
	 * @generated
	 */
   void setType(ScType value);

   /**
	 * Returns the value of the '<em><b>Plot</b></em>' attribute.
	 * The literals are from the enumeration {@link it.condarelli.writer.model.world.ScPlot}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Plot</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Plot</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScPlot
	 * @see #setPlot(ScPlot)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Plot()
	 * @model
	 * @generated
	 */
   ScPlot getPlot();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getPlot <em>Plot</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Plot</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScPlot
	 * @see #getPlot()
	 * @generated
	 */
   void setPlot(ScPlot value);

   /**
	 * Returns the value of the '<em><b>Tags</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Tags</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Tags</em>' attribute.
	 * @see #setTags(String)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Tags()
	 * @model
	 * @generated
	 */
   String getTags();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getTags <em>Tags</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tags</em>' attribute.
	 * @see #getTags()
	 * @generated
	 */
   void setTags(String value);

   /**
	 * Returns the value of the '<em><b>Status</b></em>' attribute.
	 * The literals are from the enumeration {@link it.condarelli.writer.model.world.ScStatus}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Status</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Status</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScStatus
	 * @see #setStatus(ScStatus)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Status()
	 * @model
	 * @generated
	 */
   ScStatus getStatus();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getStatus <em>Status</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Status</em>' attribute.
	 * @see it.condarelli.writer.model.world.ScStatus
	 * @see #getStatus()
	 * @generated
	 */
   void setStatus(ScStatus value);

   /**
	 * Returns the value of the '<em><b>Relevance</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Relevance</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Relevance</em>' attribute.
	 * @see #setRelevance(int)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Relevance()
	 * @model
	 * @generated
	 */
   int getRelevance();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getRelevance <em>Relevance</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relevance</em>' attribute.
	 * @see #getRelevance()
	 * @generated
	 */
   void setRelevance(int value);

   /**
	 * Returns the value of the '<em><b>Tension</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Tension</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Tension</em>' attribute.
	 * @see #setTension(int)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Tension()
	 * @model
	 * @generated
	 */
   int getTension();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getTension <em>Tension</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tension</em>' attribute.
	 * @see #getTension()
	 * @generated
	 */
   void setTension(int value);

   /**
	 * Returns the value of the '<em><b>Humor</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Humor</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Humor</em>' attribute.
	 * @see #setHumor(int)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Humor()
	 * @model
	 * @generated
	 */
   int getHumor();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getHumor <em>Humor</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Humor</em>' attribute.
	 * @see #getHumor()
	 * @generated
	 */
   void setHumor(int value);

   /**
	 * Returns the value of the '<em><b>Quality</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Quality</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Quality</em>' attribute.
	 * @see #setQuality(int)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Quality()
	 * @model
	 * @generated
	 */
   int getQuality();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getQuality <em>Quality</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Quality</em>' attribute.
	 * @see #getQuality()
	 * @generated
	 */
   void setQuality(int value);

   /**
	 * Returns the value of the '<em><b>Goal</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Goal</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Goal</em>' attribute.
	 * @see #setGoal(String)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Goal()
	 * @model
	 * @generated
	 */
   String getGoal();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getGoal <em>Goal</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Goal</em>' attribute.
	 * @see #getGoal()
	 * @generated
	 */
   void setGoal(String value);

   /**
	 * Returns the value of the '<em><b>Conflict</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Conflict</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Conflict</em>' attribute.
	 * @see #setConflict(String)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Conflict()
	 * @model
	 * @generated
	 */
   String getConflict();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getConflict <em>Conflict</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Conflict</em>' attribute.
	 * @see #getConflict()
	 * @generated
	 */
   void setConflict(String value);

   /**
	 * Returns the value of the '<em><b>Outcome</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Outcome</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Outcome</em>' attribute.
	 * @see #setOutcome(String)
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Outcome()
	 * @model
	 * @generated
	 */
   String getOutcome();

   /**
	 * Sets the value of the '{@link it.condarelli.writer.model.world.Scene#getOutcome <em>Outcome</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Outcome</em>' attribute.
	 * @see #getOutcome()
	 * @generated
	 */
   void setOutcome(String value);

   /**
	 * Returns the value of the '<em><b>Actor</b></em>' reference list.
	 * The list contents are of type {@link it.condarelli.writer.model.world.Actor}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Actor</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Actor</em>' reference list.
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Actor()
	 * @model required="true"
	 * @generated
	 */
   EList<Actor> getActor();

   /**
	 * Returns the value of the '<em><b>Location</b></em>' reference list.
	 * The list contents are of type {@link it.condarelli.writer.model.world.Location}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Location</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' reference list.
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Location()
	 * @model
	 * @generated
	 */
   EList<Location> getLocation();

   /**
	 * Returns the value of the '<em><b>Item</b></em>' reference list.
	 * The list contents are of type {@link it.condarelli.writer.model.world.Item}.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Item</em>' reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Item</em>' reference list.
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_Item()
	 * @model
	 * @generated
	 */
   EList<Item> getItem();

   /**
	 * Returns the value of the '<em><b>Word Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Word Count</em>' attribute isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
	 * @return the value of the '<em>Word Count</em>' attribute.
	 * @see it.condarelli.writer.model.world.WorldPackage#getScene_WordCount()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
   int getWordCount();

   /**
	 * @model containment="true" opposite="scene"
	 */
	EList<ScComment> getComments();


    // start of utility methods
    Scene prevScene() throws Exception;
    Scene nextScene() throws Exception;

} // Scene
