/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.impl;

import it.condarelli.writer.model.world.IBase;
import it.condarelli.writer.model.world.Timeline;
import it.condarelli.writer.model.world.WorldPackage;

import java.security.InvalidParameterException;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
class cat {
    public static final String DEFAULT_CATEGORY = "(default)";
    
    private static Map<String, cat> cats  = new HashMap<String, cat>();

    private String                  name;
    private List<TimelineImpl>      nodes = new LinkedList<TimelineImpl>();

    private cat(String category) {
        name = category;
        cats.put(name, this);
    }

    static public void add(TimelineImpl tn) {
        add(DEFAULT_CATEGORY, tn);
    }

    static public void add(String category, TimelineImpl tn) {
        cat c = cats.get(category);
        if (c == null) {
            c = new cat(category);
        }
        if (c.nodes.contains(tn))
            c.nodes.remove(tn);
        c.nodes.add(tn);
    }

    static public void add(String category, TimelineImpl tn, TimelineImpl prev) {
        cat c = cats.get(category);
        if (c == null) {
            c = new cat(category);
        }
        if (c.nodes.contains(tn))
            c.nodes.remove(tn);
        int idx = c.nodes.indexOf(prev);
        c.nodes.add(idx + 1, tn);
    }

    static public void move(String category, TimelineImpl tn) {
        String pc = tn.getCategory();
        cat c = cats.get(pc);
        if (c == null) {
            throw (new InvalidParameterException("Unknown category '" + pc + "'"));
        }
        if (!c.nodes.remove(tn)) {
            throw (new InvalidParameterException("TimeNode '" + tn.getCaption() + "' was not found in category '" + pc + "'"));
        }
        c = cats.get(category);
        if (c == null) {
            c = new cat(category);
        }
        for (int i = 0; i < c.nodes.size(); i++)
            if (c.nodes.get(i).getMillis() > tn.getMillis()) {
                c.nodes.add(i, tn);
                return;
            }
        c.nodes.add(tn);
    }
    
    static List<TimelineImpl> get(String name) {
        cat c = cats.get(name);
        if (c == null) {
            c = new cat(name);
        }
        return c.nodes;
    }
}

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Timeline</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getParent <em>Parent</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getMillis <em>Millis</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getDuration <em>Duration</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getCaption <em>Caption</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getCategory <em>Category</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getPrev <em>Prev</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getNext <em>Next</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getSync <em>Sync</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getStartDate <em>Start Date</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getEndDate <em>End Date</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getSpansDays <em>Spans Days</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getSpansHours <em>Spans Hours</em>}</li>
 *   <li>{@link it.condarelli.writer.model.world.impl.TimelineImpl#getSpansMinutes <em>Spans Minutes</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TimelineImpl extends EObjectImpl implements Timeline {
   /**
	 * The default value of the '{@link #getMillis() <em>Millis</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getMillis()
	 * @generated
	 * @ordered
	 */
   protected static final long MILLIS_EDEFAULT = 0L;

   /**
	 * The cached value of the '{@link #getMillis() <em>Millis</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getMillis()
	 * @generated
	 * @ordered
	 */
   protected long millis = MILLIS_EDEFAULT;

   /**
	 * The default value of the '{@link #getDuration() <em>Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getDuration()
	 * @generated
	 * @ordered
	 */
   protected static final long DURATION_EDEFAULT = 0L;

   /**
	 * The cached value of the '{@link #getDuration() <em>Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getDuration()
	 * @generated
	 * @ordered
	 */
   protected long duration = DURATION_EDEFAULT;

   /**
	 * The default value of the '{@link #getCaption() <em>Caption</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getCaption()
	 * @generated
	 * @ordered
	 */
   protected static final String CAPTION_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getCaption() <em>Caption</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getCaption()
	 * @generated
	 * @ordered
	 */
   protected String caption = CAPTION_EDEFAULT;

   /**
	 * The default value of the '{@link #getCategory() <em>Category</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getCategory()
	 * @generated
	 * @ordered
	 */
   protected static final String CATEGORY_EDEFAULT = null;

   /**
	 * The cached value of the '{@link #getCategory() <em>Category</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getCategory()
	 * @generated
	 * @ordered
	 */
   protected String category = CATEGORY_EDEFAULT;

   /**
	 * The cached value of the '{@link #getPrev() <em>Prev</em>}' reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getPrev()
	 * @generated
	 * @ordered
	 */
   protected Timeline prev;

   /**
	 * The cached value of the '{@link #getNext() <em>Next</em>}' reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getNext()
	 * @generated
	 * @ordered
	 */
   protected Timeline next;

   /**
	 * The cached value of the '{@link #getSync() <em>Sync</em>}' reference.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getSync()
	 * @generated
	 * @ordered
	 */
   protected Timeline sync;

   /**
	 * The default value of the '{@link #getStartDate() <em>Start Date</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getStartDate()
	 * @generated
	 * @ordered
	 */
   protected static final Date START_DATE_EDEFAULT = null;

   /**
	 * The default value of the '{@link #getEndDate() <em>End Date</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getEndDate()
	 * @generated
	 * @ordered
	 */
   protected static final Date END_DATE_EDEFAULT = null;

   /**
	 * The default value of the '{@link #getSpansDays() <em>Spans Days</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getSpansDays()
	 * @generated
	 * @ordered
	 */
   protected static final int SPANS_DAYS_EDEFAULT = 0;

   /**
	 * The default value of the '{@link #getSpansHours() <em>Spans Hours</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getSpansHours()
	 * @generated
	 * @ordered
	 */
   protected static final int SPANS_HOURS_EDEFAULT = 0;

   /**
	 * The default value of the '{@link #getSpansMinutes() <em>Spans Minutes</em>}' attribute.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @see #getSpansMinutes()
	 * @generated
	 * @ordered
	 */
   protected static final int SPANS_MINUTES_EDEFAULT = 0;

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected TimelineImpl() {
		super();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   protected EClass eStaticClass() {
		return WorldPackage.Literals.TIMELINE;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public IBase getParent() {
		if (eContainerFeatureID() != WorldPackage.TIMELINE__PARENT) return null;
		return (IBase)eContainer();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public long getMillis() {
		return millis;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setMillis(long newMillis) {
		long oldMillis = millis;
		millis = newMillis;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__MILLIS, oldMillis, millis));
	}

    public void updateMillis(long value) {
        long delta = value - millis;
        addToMillis(delta);
    }
    
    public void addToMillis(long delta) {
        setMillis(millis + delta);
        if (next != null)
            next.addToMillis(delta);
        if (sync != null)
            sync.addToMillis(delta);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public long getDuration() {
		return duration;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setDuration(long newDuration) {
		long oldDuration = duration;
		duration = newDuration;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__DURATION, oldDuration, duration));
	}

    public void adjustDuration(long newDuration) {
        Calendar c = Calendar.getInstance();
        c.setTime(new Date(millis));
        c.set(Calendar.HOUR_OF_DAY, 23);
        c.set(Calendar.MINUTE, 59);
        long delta = newDuration - duration;
        long span = c.getTime().getTime();
        setDuration(newDuration);
        if (next != null)
            ((TimelineImpl)next).adjustMillis(delta, span);
        if (sync != null)
            ((TimelineImpl)sync).adjustMillis(delta, span);
    }
    private void adjustMillis(long delta, long span) {
        if (millis > span)
            return;
        setMillis(millis + delta);
        if (next != null)
            ((TimelineImpl)next).adjustMillis(delta, span);
        if (sync != null)
            ((TimelineImpl)sync).adjustMillis(delta, span);
    }
    
    
   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public String getCaption() {
        return (caption != null) ? caption : getParent().getTitle();
   }

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setCaption(String newCaption) {
		String oldCaption = caption;
		caption = newCaption;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__CAPTION, oldCaption, caption));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String getCategory() {
		return category;
	}

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * 
     * @generated NOT
    */
   public void setCategory(String newCategory) {
        if (newCategory.equals(category))
            return;
      String oldCategory = category;
      category = newCategory;
        if (oldCategory != null)
            cat.move(newCategory, this);
        else
            cat.add(newCategory, this);
      if (eNotificationRequired())
         eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__CATEGORY, oldCategory, category));
   }

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline getPrev() {
		if (prev != null && prev.eIsProxy()) {
			InternalEObject oldPrev = (InternalEObject)prev;
			prev = (Timeline)eResolveProxy(oldPrev);
			if (prev != oldPrev) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, WorldPackage.TIMELINE__PREV, oldPrev, prev));
			}
		}
		return prev;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline basicGetPrev() {
		return prev;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setPrev(Timeline newPrev) {
		Timeline oldPrev = prev;
		prev = newPrev;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__PREV, oldPrev, prev));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline getNext() {
		if (next != null && next.eIsProxy()) {
			InternalEObject oldNext = (InternalEObject)next;
			next = (Timeline)eResolveProxy(oldNext);
			if (next != oldNext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, WorldPackage.TIMELINE__NEXT, oldNext, next));
			}
		}
		return next;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline basicGetNext() {
		return next;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setNext(Timeline newNext) {
		Timeline oldNext = next;
		next = newNext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__NEXT, oldNext, next));
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline getSync() {
		if (sync != null && sync.eIsProxy()) {
			InternalEObject oldSync = (InternalEObject)sync;
			sync = (Timeline)eResolveProxy(oldSync);
			if (sync != oldSync) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, WorldPackage.TIMELINE__SYNC, oldSync, sync));
			}
		}
		return sync;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline basicGetSync() {
		return sync;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public void setSync(Timeline newSync) {
		Timeline oldSync = sync;
		sync = newSync;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorldPackage.TIMELINE__SYNC, oldSync, sync));
	}

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public Date getStartDate() {
        Date d = new Date(getMillis());
        return d;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public void setStartDate(Date newStartDate) {
        setMillis(newStartDate.getTime());
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public Date getEndDate() {
        Date d = new Date(getMillis() + getDuration());
        return d;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public void setEndDate(Date newEndDate) {
        adjustDuration(newEndDate.getTime() - getMillis());
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public int getSpansDays() {
        long dur = getDuration();
        dur /= (24 * 60 * 60 * 1000);
        return (int) dur;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public void setSpansDays(int newSpansDays) {
        long dur = getDuration();
        dur -= dur / (24 * 60 * 60 * 1000);
        dur += newSpansDays * (24 * 60 * 60 * 1000);
        adjustDuration(dur);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public int getSpansHours() {
        long dur = duration;
        dur /= (60 * 60 * 1000);
        return (int) (dur % 24);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public void setSpansHours(int newSpansHours) {
        long dur = getDuration();
        dur -= dur / (60 * 60 * 1000);
        dur += newSpansHours * (60 * 60 * 1000);
        adjustDuration(dur);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public int getSpansMinutes() {
        long dur = duration;
        dur /= (60 * 1000);
        return (int) (dur % 60);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
     * @generated NOT
    */
   public void setSpansMinutes(int newSpansMinutes) {
        long dur = getDuration();
        dur -= dur / (60 * 1000);
        dur += newSpansMinutes * (60 * 1000);
        adjustDuration(dur);
   }

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.TIMELINE__PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, WorldPackage.TIMELINE__PARENT, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorldPackage.TIMELINE__PARENT:
				return eBasicSetContainer(null, WorldPackage.TIMELINE__PARENT, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case WorldPackage.TIMELINE__PARENT:
				return eInternalContainer().eInverseRemove(this, WorldPackage.IBASE__TIMELINE, IBase.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorldPackage.TIMELINE__PARENT:
				return getParent();
			case WorldPackage.TIMELINE__MILLIS:
				return getMillis();
			case WorldPackage.TIMELINE__DURATION:
				return getDuration();
			case WorldPackage.TIMELINE__CAPTION:
				return getCaption();
			case WorldPackage.TIMELINE__CATEGORY:
				return getCategory();
			case WorldPackage.TIMELINE__PREV:
				if (resolve) return getPrev();
				return basicGetPrev();
			case WorldPackage.TIMELINE__NEXT:
				if (resolve) return getNext();
				return basicGetNext();
			case WorldPackage.TIMELINE__SYNC:
				if (resolve) return getSync();
				return basicGetSync();
			case WorldPackage.TIMELINE__START_DATE:
				return getStartDate();
			case WorldPackage.TIMELINE__END_DATE:
				return getEndDate();
			case WorldPackage.TIMELINE__SPANS_DAYS:
				return getSpansDays();
			case WorldPackage.TIMELINE__SPANS_HOURS:
				return getSpansHours();
			case WorldPackage.TIMELINE__SPANS_MINUTES:
				return getSpansMinutes();
		}
		return super.eGet(featureID, resolve, coreType);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorldPackage.TIMELINE__MILLIS:
				setMillis((Long)newValue);
				return;
			case WorldPackage.TIMELINE__DURATION:
				setDuration((Long)newValue);
				return;
			case WorldPackage.TIMELINE__CAPTION:
				setCaption((String)newValue);
				return;
			case WorldPackage.TIMELINE__CATEGORY:
				setCategory((String)newValue);
				return;
			case WorldPackage.TIMELINE__PREV:
				setPrev((Timeline)newValue);
				return;
			case WorldPackage.TIMELINE__NEXT:
				setNext((Timeline)newValue);
				return;
			case WorldPackage.TIMELINE__SYNC:
				setSync((Timeline)newValue);
				return;
			case WorldPackage.TIMELINE__START_DATE:
				setStartDate((Date)newValue);
				return;
			case WorldPackage.TIMELINE__END_DATE:
				setEndDate((Date)newValue);
				return;
			case WorldPackage.TIMELINE__SPANS_DAYS:
				setSpansDays((Integer)newValue);
				return;
			case WorldPackage.TIMELINE__SPANS_HOURS:
				setSpansHours((Integer)newValue);
				return;
			case WorldPackage.TIMELINE__SPANS_MINUTES:
				setSpansMinutes((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public void eUnset(int featureID) {
		switch (featureID) {
			case WorldPackage.TIMELINE__MILLIS:
				setMillis(MILLIS_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__DURATION:
				setDuration(DURATION_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__CAPTION:
				setCaption(CAPTION_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__CATEGORY:
				setCategory(CATEGORY_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__PREV:
				setPrev((Timeline)null);
				return;
			case WorldPackage.TIMELINE__NEXT:
				setNext((Timeline)null);
				return;
			case WorldPackage.TIMELINE__SYNC:
				setSync((Timeline)null);
				return;
			case WorldPackage.TIMELINE__START_DATE:
				setStartDate(START_DATE_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__END_DATE:
				setEndDate(END_DATE_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__SPANS_DAYS:
				setSpansDays(SPANS_DAYS_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__SPANS_HOURS:
				setSpansHours(SPANS_HOURS_EDEFAULT);
				return;
			case WorldPackage.TIMELINE__SPANS_MINUTES:
				setSpansMinutes(SPANS_MINUTES_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorldPackage.TIMELINE__PARENT:
				return getParent() != null;
			case WorldPackage.TIMELINE__MILLIS:
				return millis != MILLIS_EDEFAULT;
			case WorldPackage.TIMELINE__DURATION:
				return duration != DURATION_EDEFAULT;
			case WorldPackage.TIMELINE__CAPTION:
				return CAPTION_EDEFAULT == null ? caption != null : !CAPTION_EDEFAULT.equals(caption);
			case WorldPackage.TIMELINE__CATEGORY:
				return CATEGORY_EDEFAULT == null ? category != null : !CATEGORY_EDEFAULT.equals(category);
			case WorldPackage.TIMELINE__PREV:
				return prev != null;
			case WorldPackage.TIMELINE__NEXT:
				return next != null;
			case WorldPackage.TIMELINE__SYNC:
				return sync != null;
			case WorldPackage.TIMELINE__START_DATE:
				return START_DATE_EDEFAULT == null ? getStartDate() != null : !START_DATE_EDEFAULT.equals(getStartDate());
			case WorldPackage.TIMELINE__END_DATE:
				return END_DATE_EDEFAULT == null ? getEndDate() != null : !END_DATE_EDEFAULT.equals(getEndDate());
			case WorldPackage.TIMELINE__SPANS_DAYS:
				return getSpansDays() != SPANS_DAYS_EDEFAULT;
			case WorldPackage.TIMELINE__SPANS_HOURS:
				return getSpansHours() != SPANS_HOURS_EDEFAULT;
			case WorldPackage.TIMELINE__SPANS_MINUTES:
				return getSpansMinutes() != SPANS_MINUTES_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (millis: ");
		result.append(millis);
		result.append(", duration: ");
		result.append(duration);
		result.append(", caption: ");
		result.append(caption);
		result.append(", category: ");
		result.append(category);
		result.append(')');
		return result.toString();
	}

    /*
     * ============================================================================================ MCon - start implementation
     * ============================================================================================
     */
    public Timeline remove() {
        if (prev != null) {
            prev.setNext(next);
        }
        if (next != null) {
            next.setPrev(prev);
        }

        return this;
    }

    public void insert(Timeline pn) {
        long t = pn.getNext().getMillis() - pn.getMillis();
        if (duration >= t) {
            duration = t;
            t = 0;
        } else {
            t = (t - duration) / 2;
        }
        prev = pn;
        next = pn.getNext();
        prev.setNext(this);
        next.setPrev(this);
    }

    public void add() {
        if (category == null) {
            category = cat.DEFAULT_CATEGORY;
        }
        List<TimelineImpl> tl = cat.get(category);
        if (tl.contains(this))
            tl.remove(this);
        next = null;
        if (tl.size() > 0) {
            Timeline pr = tl.get(tl.size()-1);
            if (pr.getNext() != null)
                System.err.println("last node does not have null terminator");
            prev = pr;
            prev.setNext(this);
        } else {
            prev = null;
        }
        tl.add(this);
    }
    
} //TimelineImpl
