/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.impl;

import it.condarelli.writer.model.world.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.jface.text.Position;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class WorldFactoryImpl extends EFactoryImpl implements WorldFactory {
   /**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public static WorldFactory init() {
		try {
			WorldFactory theWorldFactory = (WorldFactory)EPackage.Registry.INSTANCE.getEFactory("http:///it/condarelli/writer/model/world.ecore"); 
			if (theWorldFactory != null) {
				return theWorldFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new WorldFactoryImpl();
	}

   /**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public WorldFactoryImpl() {
		super();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case WorldPackage.ACTOR: return createActor();
			case WorldPackage.BOOK: return createBook();
			case WorldPackage.CHAPTER: return createChapter();
			case WorldPackage.IBASE: return createIBase();
			case WorldPackage.ITEM: return createItem();
			case WorldPackage.LOCATION: return createLocation();
			case WorldPackage.PROJECT: return createProject();
			case WorldPackage.SCENE: return createScene();
			case WorldPackage.TIMELINE: return createTimeline();
			case WorldPackage.WORLD: return createWorld();
			case WorldPackage.SC_COMMENT: return createScComment();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case WorldPackage.ACTOR_TYPE:
				return createActorTypeFromString(eDataType, initialValue);
			case WorldPackage.SC_PLOT:
				return createScPlotFromString(eDataType, initialValue);
			case WorldPackage.SC_STATUS:
				return createScStatusFromString(eDataType, initialValue);
			case WorldPackage.SC_TYPE:
				return createScTypeFromString(eDataType, initialValue);
			case WorldPackage.SC_COMMENT_TYPE:
				return createScCommentTypeFromString(eDataType, initialValue);
			case WorldPackage.IMAGE:
				return createImageFromString(eDataType, initialValue);
			case WorldPackage.POINT:
				return createPointFromString(eDataType, initialValue);
			case WorldPackage.ACTOR_ARRAY:
				return createActorArrayFromString(eDataType, initialValue);
			case WorldPackage.LOCATION_ARRAY:
				return createLocationArrayFromString(eDataType, initialValue);
			case WorldPackage.ITEM_ARRAY:
				return createItemArrayFromString(eDataType, initialValue);
			case WorldPackage.ACTOR_ARRAY_1:
				return createActorArray_1FromString(eDataType, initialValue);
			case WorldPackage.LOCATION_ARRAY_1:
				return createLocationArray_1FromString(eDataType, initialValue);
			case WorldPackage.ITEM_ARRAY_1:
				return createItemArray_1FromString(eDataType, initialValue);
			case WorldPackage.POSITION:
				return createPositionFromString(eDataType, initialValue);
			case WorldPackage.MODEL:
				return createModelFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   @Override
   public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case WorldPackage.ACTOR_TYPE:
				return convertActorTypeToString(eDataType, instanceValue);
			case WorldPackage.SC_PLOT:
				return convertScPlotToString(eDataType, instanceValue);
			case WorldPackage.SC_STATUS:
				return convertScStatusToString(eDataType, instanceValue);
			case WorldPackage.SC_TYPE:
				return convertScTypeToString(eDataType, instanceValue);
			case WorldPackage.SC_COMMENT_TYPE:
				return convertScCommentTypeToString(eDataType, instanceValue);
			case WorldPackage.IMAGE:
				return convertImageToString(eDataType, instanceValue);
			case WorldPackage.POINT:
				return convertPointToString(eDataType, instanceValue);
			case WorldPackage.ACTOR_ARRAY:
				return convertActorArrayToString(eDataType, instanceValue);
			case WorldPackage.LOCATION_ARRAY:
				return convertLocationArrayToString(eDataType, instanceValue);
			case WorldPackage.ITEM_ARRAY:
				return convertItemArrayToString(eDataType, instanceValue);
			case WorldPackage.ACTOR_ARRAY_1:
				return convertActorArray_1ToString(eDataType, instanceValue);
			case WorldPackage.LOCATION_ARRAY_1:
				return convertLocationArray_1ToString(eDataType, instanceValue);
			case WorldPackage.ITEM_ARRAY_1:
				return convertItemArray_1ToString(eDataType, instanceValue);
			case WorldPackage.POSITION:
				return convertPositionToString(eDataType, instanceValue);
			case WorldPackage.MODEL:
				return convertModelToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Actor createActor() {
		ActorImpl actor = new ActorImpl();
		return actor;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Book createBook() {
		BookImpl book = new BookImpl();
		return book;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Chapter createChapter() {
		ChapterImpl chapter = new ChapterImpl();
		return chapter;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public IBase createIBase() {
		IBaseImpl iBase = new IBaseImpl();
		return iBase;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Item createItem() {
		ItemImpl item = new ItemImpl();
		return item;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Location createLocation() {
		LocationImpl location = new LocationImpl();
		return location;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Project createProject() {
		ProjectImpl project = new ProjectImpl();
		return project;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Scene createScene() {
		SceneImpl scene = new SceneImpl();
		return scene;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Timeline createTimeline() {
		TimelineImpl timeline = new TimelineImpl();
		return timeline;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public World createWorld() {
		WorldImpl world = new WorldImpl();
		return world;
	}

   /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScComment createScComment() {
		ScCommentImpl scComment = new ScCommentImpl();
		return scComment;
	}

			/**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ActorType createActorTypeFromString(EDataType eDataType, String initialValue) {
		ActorType result = ActorType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertActorTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScPlot createScPlotFromString(EDataType eDataType, String initialValue) {
		ScPlot result = ScPlot.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertScPlotToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScStatus createScStatusFromString(EDataType eDataType, String initialValue) {
		ScStatus result = ScStatus.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertScStatusToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public ScType createScTypeFromString(EDataType eDataType, String initialValue) {
		ScType result = ScType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertScTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

   /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScCommentType createScCommentTypeFromString(EDataType eDataType, String initialValue) {
		ScCommentType result = ScCommentType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

			/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertScCommentTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

			/**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Image createImageFromString(EDataType eDataType, String initialValue) {
		return (Image)super.createFromString(eDataType, initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertImageToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Point createPointFromString(EDataType eDataType, String initialValue) {
		return (Point)super.createFromString(eDataType, initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertPointToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Actor[] createActorArrayFromString(EDataType eDataType, String initialValue) {
		return (Actor[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertActorArrayToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Location[] createLocationArrayFromString(EDataType eDataType, String initialValue) {
		return (Location[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertLocationArrayToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Item[] createItemArrayFromString(EDataType eDataType, String initialValue) {
		return (Item[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertItemArrayToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Actor[] createActorArray_1FromString(EDataType eDataType, String initialValue) {
		return (Actor[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertActorArray_1ToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Location[] createLocationArray_1FromString(EDataType eDataType, String initialValue) {
		return (Location[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertLocationArray_1ToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public Item[] createItemArray_1FromString(EDataType eDataType, String initialValue) {
		return (Item[])super.createFromString(initialValue);
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public String convertItemArray_1ToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

   /**
    * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
    * @generated NOT
    */
	public Position createPositionFromString(EDataType eDataType, String initialValue) {
	   int p = initialValue.indexOf(';');
	   if (p < 0)
	      return null;
	   int pos = Integer.parseInt(initialValue.substring(0, p));
	   int len = Integer.parseInt(initialValue.substring(p+1));
      return new Position(pos, len);
   }

			/**
    * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
    * @generated NOT
    */
	public String convertPositionToString(EDataType eDataType, Object instanceValue) {
	   if (instanceValue instanceof Position) {
         Position pos = (Position) instanceValue;
         return String.valueOf(pos.getOffset())+";"+String.valueOf(pos.getLength());
      }
      return super.convertToString(eDataType, instanceValue);
   }

			/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model createModelFromString(EDataType eDataType, String initialValue) {
		return (Model)super.createFromString(eDataType, initialValue);
	}

			/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertModelToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

			/**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public WorldPackage getWorldPackage() {
		return (WorldPackage)getEPackage();
	}

   /**
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
   @Deprecated
   public static WorldPackage getPackage() {
		return WorldPackage.eINSTANCE;
	}

} //WorldFactoryImpl
