/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package it.condarelli.writer.model.world.util;

import it.condarelli.writer.model.world.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see it.condarelli.writer.model.world.WorldPackage
 * @generated
 */
public class WorldAdapterFactory extends AdapterFactoryImpl {
   /**
	 * The cached model package.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected static WorldPackage modelPackage;

   /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   public WorldAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = WorldPackage.eINSTANCE;
		}
	}

   /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
    * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
    * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
   @Override
   public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

   /**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @generated
	 */
   protected WorldSwitch<Adapter> modelSwitch =
      new WorldSwitch<Adapter>() {
			@Override
			public Adapter caseActor(Actor object) {
				return createActorAdapter();
			}
			@Override
			public Adapter caseBook(Book object) {
				return createBookAdapter();
			}
			@Override
			public Adapter caseChapter(Chapter object) {
				return createChapterAdapter();
			}
			@Override
			public Adapter caseIBase(IBase object) {
				return createIBaseAdapter();
			}
			@Override
			public Adapter caseItem(Item object) {
				return createItemAdapter();
			}
			@Override
			public Adapter caseLocation(Location object) {
				return createLocationAdapter();
			}
			@Override
			public Adapter caseProject(Project object) {
				return createProjectAdapter();
			}
			@Override
			public Adapter caseScene(Scene object) {
				return createSceneAdapter();
			}
			@Override
			public Adapter caseTimeline(Timeline object) {
				return createTimelineAdapter();
			}
			@Override
			public Adapter caseWorld(World object) {
				return createWorldAdapter();
			}
			@Override
			public Adapter caseScComment(ScComment object) {
				return createScCommentAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

   /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
   @Override
   public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Actor <em>Actor</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Actor
	 * @generated
	 */
   public Adapter createActorAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Book <em>Book</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Book
	 * @generated
	 */
   public Adapter createBookAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Chapter <em>Chapter</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Chapter
	 * @generated
	 */
   public Adapter createChapterAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.IBase <em>IBase</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.IBase
	 * @generated
	 */
   public Adapter createIBaseAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Item <em>Item</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Item
	 * @generated
	 */
   public Adapter createItemAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Location <em>Location</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Location
	 * @generated
	 */
   public Adapter createLocationAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Project <em>Project</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Project
	 * @generated
	 */
   public Adapter createProjectAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Scene <em>Scene</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Scene
	 * @generated
	 */
   public Adapter createSceneAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.Timeline <em>Timeline</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.Timeline
	 * @generated
	 */
   public Adapter createTimelineAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.World <em>World</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.World
	 * @generated
	 */
   public Adapter createWorldAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for an object of class '{@link it.condarelli.writer.model.world.ScComment <em>Sc Comment</em>}'.
	 * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.condarelli.writer.model.world.ScComment
	 * @generated
	 */
	public Adapter createScCommentAdapter() {
		return null;
	}

   /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
    * This default implementation returns null.
    * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
   public Adapter createEObjectAdapter() {
		return null;
	}

} //WorldAdapterFactory
